Index: issm/trunk/src/c/classes/Params/TransientParam.cpp
===================================================================
--- issm/trunk/src/c/classes/Params/TransientParam.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Params/TransientParam.cpp	(revision 26744)
@@ -20,17 +20,18 @@
 }
 /*}}}*/
-TransientParam::TransientParam(int in_enum_type,IssmDouble* in_values,IssmDouble* in_time,bool interpolation_on,int in_N){/*{{{*/
+TransientParam::TransientParam(int in_enum_type,IssmDouble* in_values,IssmDouble* in_time,bool interpolation_on,bool cycle_in,int in_N){/*{{{*/
 
 	_assert_(in_values && in_time);
 
-	enum_type=in_enum_type;
-	N=in_N;
-	interpolation=interpolation_on;
+	this->enum_type=in_enum_type;
+	this->N=in_N;
+	this->interpolation=interpolation_on;
+	this->cycle=cycle_in;
 
-	values=xNew<IssmDouble>(N);
-	xMemCpy<IssmDouble>(values,in_values,N);
+	this->values=xNew<IssmDouble>(N);
+	xMemCpy<IssmDouble>(this->values,in_values,N);
 
-	timesteps=xNew<IssmDouble>(N);
-	xMemCpy<IssmDouble>(timesteps,in_time,N);
+	this->timesteps=xNew<IssmDouble>(N);
+	xMemCpy<IssmDouble>(this->timesteps,in_time,N);
 }
 /*}}}*/
@@ -44,5 +45,5 @@
 Param* TransientParam::copy() {/*{{{*/
 
-	return new TransientParam(this->enum_type,this->values,this->timesteps,this->interpolation,this->N);
+	return new TransientParam(this->enum_type,this->values,this->timesteps,this->interpolation,this->cycle,this->N);
 
 }
@@ -75,4 +76,5 @@
 	marshallhandle->call(this->enum_type);
 	marshallhandle->call(this->interpolation);
+	marshallhandle->call(this->cycle);
 	marshallhandle->call(this->N);
 	if(marshallhandle->OperationNumber()==MARSHALLING_LOAD){
@@ -97,4 +99,6 @@
 	IssmDouble output;
 	bool   found;
+
+	if(this->cycle) _error_("not implemented yet!");
 
 	/*Ok, we have the time, go through the timesteps, and figure out which interval we 
@@ -124,5 +128,5 @@
 					IssmDouble deltat=this->timesteps[i+1]-this->timesteps[i];
 					IssmDouble alpha=(time-this->timesteps[i])/deltat;
-					if(interpolation==true) output=(1.0-alpha)*this->values[i] + alpha*this->values[i+1];
+					if(this->interpolation==true) output=(1.0-alpha)*this->values[i] + alpha*this->values[i+1];
 					else output=this->values[i];
 					found=true;
Index: issm/trunk/src/c/classes/Params/TransientParam.h
===================================================================
--- issm/trunk/src/c/classes/Params/TransientParam.h	(revision 25994)
+++ issm/trunk/src/c/classes/Params/TransientParam.h	(revision 26744)
@@ -24,4 +24,5 @@
 		int         N;
 		bool        interpolation;
+		bool        cycle;
 		IssmDouble *values;
 		IssmDouble *timesteps;
@@ -30,5 +31,5 @@
 		/*TransientParam constructors, destructors: {{{*/
 		TransientParam();
-		TransientParam(int in_enum_type,IssmDouble* in_values,IssmDouble* in_time,bool interpolation_on,int in_N);
+		TransientParam(int in_enum_type,IssmDouble* in_values,IssmDouble* in_time,bool interpolation_in,bool cycle_in,int in_N);
 		~TransientParam();
 		/*}}}*/
Index: issm/trunk/src/c/classes/Profiler.h
===================================================================
--- issm/trunk/src/c/classes/Profiler.h	(revision 25994)
+++ issm/trunk/src/c/classes/Profiler.h	(revision 26744)
@@ -22,19 +22,19 @@
 #define MOVINGFRONTCORE		9 /*Profiling MOVINGFRONT */
 #define MASSTRANSPORTCORE	10 /*Profiling MASSTRANSPORT */
-#define SMBCORE				11 /*Profiling SMB */
-#define GROUNDINGLINECORE	12 /*Profiling GROUDINGLINE MIGRATION */
-#define GIACORE				13 /*Profiling GIA */
+#define OCEANTRANSPORTCORE	11 /*Profiling OCEANTRANSPORT */
+#define SMBCORE				12 /*Profiling SMB */
+#define GROUNDINGLINECORE	13 /*Profiling GROUDINGLINE MIGRATION */
 #define ESACORE				14 /*Profiling ESA */
 #define SLRCORE				15 /*Profiling SLR */
-#define MPISERIAL				16 /*Profiling MPISerial */
-#define SEDLOOP				17 /*Profiling MPISerial */
-#define SEDMatrix				18 /*Profiling MPISerial */
-#define SEDUpdate				19 /*Profiling MPISerial */
-#define EPLLOOP				20 /*Profiling MPISerial */
-#define EPLMasking			21 /*Profiling MPISerial */
-#define EPLMatrices			22 /*Profiling MPISerial */
-#define EPLUpdate				23 /*Profiling MPISerial */
-#define MAXPROFSIZE			24 /*Used to initialize static arrays*/
-
+#define SAMPLINGCORE	16 /*Profiling SAMPLING */
+#define MPISERIAL				17 /*Profiling MPISerial */
+#define SEDLOOP				18 /*Profiling MPISerial */
+#define SEDMatrix				19 /*Profiling MPISerial */
+#define SEDUpdate				20 /*Profiling MPISerial */
+#define EPLLOOP				21 /*Profiling MPISerial */
+#define EPLMasking			22 /*Profiling MPISerial */
+#define EPLMatrices			23 /*Profiling MPISerial */
+#define EPLUpdate				24 /*Profiling MPISerial */
+#define MAXPROFSIZE			25 /*Used to initialize static arrays*/
 
 class Profiler: public Object{
Index: issm/trunk/src/c/classes/SealevelGeometry.cpp
===================================================================
--- issm/trunk/src/c/classes/SealevelGeometry.cpp	(revision 26744)
+++ issm/trunk/src/c/classes/SealevelGeometry.cpp	(revision 26744)
@@ -0,0 +1,156 @@
+/*
+ * \file SealevelGeometry.cpp
+ * \brief: Implementation of SealevelGeometry class
+ */
+
+/*Headers: {{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "./SealevelGeometry.h"
+
+using namespace std;
+/*}}}*/
+
+/*Object constructors and destructor*/
+SealevelGeometry::SealevelGeometry(int localnelin,int localnodsin){ /*{{{*/
+	localnel=localnelin;
+	for(int i=0;i<SLGEOM_NUMLOADS;i++){
+		for (int j=0;j<SLMAXVERTICES;j++){
+			LoadWeigths[i][j]=xNewZeroInit<IssmDouble>(localnel);
+		}
+		vlatbarycentre[i]=NULL; //we don't know yet 
+		vlongbarycentre[i]=NULL;
+		vareae_subel[i]=NULL;
+		latbarycentre[i]=NULL; //we don't know yet 
+		longbarycentre[i]=NULL;
+		area_subel[i]=NULL;
+
+		LoadArea[i]=xNewZeroInit<IssmDouble>(localnel);
+		issubelement[i]=xNewZeroInit<bool>(localnel);
+		subelementmapping[i]=NULL;
+		nsubel[i]=0;
+		nbar[i]=0;
+	}
+	late=xNew<IssmDouble>(localnel);
+	longe=xNew<IssmDouble>(localnel);
+	isoceanin=xNew<bool>(localnel);
+	lids=xNew<int>(localnodsin);
+
+}; /*}}}*/
+SealevelGeometry::~SealevelGeometry(){ /*{{{*/
+	for(int i=0;i<SLGEOM_NUMLOADS;i++){
+		for (int j=0;j<SLMAXVERTICES;j++){
+			xDelete<IssmDouble>(LoadWeigths[i][j]);
+		}
+		xDelete<IssmDouble>(LoadArea[i]);
+		xDelete<bool>(issubelement[i]);
+		xDelete<int>(subelementmapping[i]);
+		delete  vlatbarycentre[i];
+		delete  vlongbarycentre[i];
+		delete  vareae_subel[i];
+		xDelete<IssmDouble>(latbarycentre[i]);
+		xDelete<IssmDouble>(longbarycentre[i]);
+		xDelete<IssmDouble>(area_subel[i]);
+	}
+	xDelete<IssmDouble>(late);
+	xDelete<IssmDouble>(longe);
+	xDelete<bool>(isoceanin);
+	xDelete<int>(lids);
+}; /*}}}*/
+
+void SealevelGeometry::InitializeMappingsAndBarycentres(void){ /*{{{*/
+
+	int dummy;
+	bool fromlocalsize=true;
+	int lower_row;
+
+	for (int i=0;i<SLGEOM_NUMLOADS;i++){
+		subelementmapping[i]=xNew<int>(localnel);
+		GetOwnershipBoundariesFromRange(&lower_row,&dummy,nsubel[i],IssmComm::GetComm());
+
+		int count=0;
+		for (int j=0;j<localnel;j++){
+			if(issubelement[i][j]){
+				subelementmapping[i][j]=lower_row+count;
+				count++;
+			}
+		}
+	}
+
+	/*Initialize barycentre vectors, now that we know their size: */
+	for (int i=0;i<SLGEOM_NUMLOADS;i++){
+		vlatbarycentre[i]=new Vector<IssmDouble>(nsubel[i],fromlocalsize);
+		vlongbarycentre[i]=new Vector<IssmDouble>(nsubel[i],fromlocalsize);
+		vareae_subel[i]=new Vector<IssmDouble>(nsubel[i],fromlocalsize);
+		vlatbarycentre[i]->GetSize(&nbar[i]);
+	}
+
+} /*}}}*/
+void SealevelGeometry::Assemble(void){ /*{{{*/
+
+	/*Initialize barycentre vectors, now that we know their size: */
+	for (int i=0;i<SLGEOM_NUMLOADS;i++){
+		vlatbarycentre[i]->Assemble();
+		vlongbarycentre[i]->Assemble();
+		vareae_subel[i]->Assemble();
+
+		latbarycentre[i]=vlatbarycentre[i]->ToMPISerial();
+		longbarycentre[i]=vlongbarycentre[i]->ToMPISerial();
+		area_subel[i]=vareae_subel[i]->ToMPISerial();
+	}
+
+	/*Also, we'll need the barycentre associated areas:*/
+
+} /*}}}*/
+int SealevelGeometry::GEnum(int l){ /*{{{*/
+
+	int output = -1;
+	switch(l){
+		case SLGEOM_OCEAN: output=SealevelchangeGsubelOceanEnum; break;
+		case SLGEOM_ICE:   output=SealevelchangeGsubelIceEnum;   break;
+		case SLGEOM_WATER: output=SealevelchangeGsubelHydroEnum; break;
+		default: _error_("not supported");
+	}
+	return output;
+
+} /*}}}*/
+int SealevelGeometry::GUEnum(int l){ /*{{{*/
+
+	int output = -1;
+	switch(l){
+		case SLGEOM_OCEAN: output=SealevelchangeGUsubelOceanEnum; break;
+		case SLGEOM_ICE:   output=SealevelchangeGUsubelIceEnum;   break;
+		case SLGEOM_WATER: output=SealevelchangeGUsubelHydroEnum; break;
+		default: _error_("not supported");
+	}
+	return output;
+
+} /*}}}*/
+int SealevelGeometry::GNEnum(int l){ /*{{{*/
+
+	int output = -1;
+	switch(l){
+		case SLGEOM_OCEAN: output=SealevelchangeGNsubelOceanEnum; break;
+		case SLGEOM_ICE:   output=SealevelchangeGNsubelIceEnum;   break;
+		case SLGEOM_WATER: output=SealevelchangeGNsubelHydroEnum; break;
+		default: _error_("not supported");
+	}
+
+	return output;
+} /*}}}*/
+int SealevelGeometry::GEEnum(int l){ /*{{{*/
+
+	int output = -1;
+	switch(l){
+		case SLGEOM_OCEAN: output=SealevelchangeGEsubelOceanEnum; break;
+		case SLGEOM_ICE:   output=SealevelchangeGEsubelIceEnum;   break;
+		case SLGEOM_WATER: output=SealevelchangeGEsubelHydroEnum; break;
+		default: _error_("not supported");
+	}
+	return output;
+
+} /*}}}*/
Index: issm/trunk/src/c/classes/SealevelGeometry.h
===================================================================
--- issm/trunk/src/c/classes/SealevelGeometry.h	(revision 26744)
+++ issm/trunk/src/c/classes/SealevelGeometry.h	(revision 26744)
@@ -0,0 +1,48 @@
+/*!\file SealevelGeometry.h
+ * \brief: header file for SealevelMask geometry
+ */
+
+#ifndef _SEALEVELGEOMETRY_H_
+#define _SEALEVELGEOMETRY_H_
+
+/*Headers:*/
+#define SLGEOM_NUMLOADS 3
+#define SLGEOM_OCEAN 0 
+#define SLGEOM_ICE 1 
+#define SLGEOM_WATER 2
+#define SLMAXVERTICES 3
+
+#include "../toolkits/toolkits.h"
+
+class SealevelGeometry{ 
+
+	public: 
+
+		int         localnel;
+		IssmDouble* LoadWeigths[SLGEOM_NUMLOADS][SLMAXVERTICES];
+		IssmDouble* LoadArea[SLGEOM_NUMLOADS];
+		Vector<IssmDouble>* vlatbarycentre[SLGEOM_NUMLOADS];
+		Vector<IssmDouble>* vlongbarycentre[SLGEOM_NUMLOADS];
+		Vector<IssmDouble>* vareae_subel[SLGEOM_NUMLOADS];
+		IssmDouble* latbarycentre[SLGEOM_NUMLOADS];
+		IssmDouble* longbarycentre[SLGEOM_NUMLOADS];
+		IssmDouble* area_subel[SLGEOM_NUMLOADS];
+		IssmDouble* late;
+		IssmDouble* longe;
+		bool* isoceanin;
+		bool*       issubelement[SLGEOM_NUMLOADS]; 
+		int*        subelementmapping[SLGEOM_NUMLOADS];
+		int         nsubel[SLGEOM_NUMLOADS];
+		int         nbar[SLGEOM_NUMLOADS];
+		int*        lids; 
+
+		SealevelGeometry(int localnel,int localnods);
+		~SealevelGeometry();
+		void InitializeMappingsAndBarycentres(void);
+		void Assemble(void);
+		int GEnum(int l);
+		int GUEnum(int l);
+		int GNEnum(int l);
+		int GEEnum(int l);
+};
+#endif  /* _SEALEVELGEOMETRY_H_ */
Index: issm/trunk/src/c/classes/Vertex.cpp
===================================================================
--- issm/trunk/src/c/classes/Vertex.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Vertex.cpp	(revision 26744)
@@ -182,4 +182,5 @@
 	switch(this->domaintype){
 		case Domain2DhorizontalEnum:
+		case Domain3DsurfaceEnum:
 			/*Nothing*/
 			return;
Index: issm/trunk/src/c/classes/classes.h
===================================================================
--- issm/trunk/src/c/classes/classes.h	(revision 25994)
+++ issm/trunk/src/c/classes/classes.h	(revision 26744)
@@ -18,5 +18,7 @@
 #include "./Massfluxatgate.h"
 #include "./Misfit.h"
-#include "./SealevelMasks.h"
+#include "./SealevelGeometry.h"
+#include "./GrdLoads.h"
+#include "./BarystaticContributions.h"
 #include "./Nodalvalue.h"
 #include "./Numberedcostfunction.h"
@@ -24,4 +26,5 @@
 #include "./Cfdragcoeffabsgrad.h"
 #include "./Cfsurfacelogvel.h"
+#include "./Cflevelsetmisfit.h"
 #include "./Masscon.h"
 #include "./Massconaxpby.h"
Index: issm/trunk/src/c/classes/gauss/GaussTria.cpp
===================================================================
--- issm/trunk/src/c/classes/gauss/GaussTria.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/gauss/GaussTria.cpp	(revision 26744)
@@ -636,6 +636,13 @@
 } /*}}}*/
 void GaussTria::SynchronizeGaussBase(Gauss* gauss){/*{{{*/
-
-	_error_("not supported");
-}
-/*}}}*/
+	//itapopo check this
+	_assert_(gauss->Enum()==GaussTriaEnum);
+   GaussTria* gauss_tria = xDynamicCast<GaussTria*>(gauss);
+
+   gauss_tria->coord1=this->coord1;
+   gauss_tria->coord2=this->coord2;
+   gauss_tria->coord3=this->coord3;
+   gauss_tria->weight=UNDEF;
+	//_error_("not supported");
+}
+/*}}}*/
